package org.xtext.example.mydsl.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.mydsl.services.MyDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDslParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'('", "')'", "','", "'if:'", "'='"
    };
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=4;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int RULE_INT=6;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalMyDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMyDsl.g"; }


    	private MyDslGrammarAccess grammarAccess;

    	public void setGrammarAccess(MyDslGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleModel"
    // InternalMyDsl.g:53:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // InternalMyDsl.g:54:1: ( ruleModel EOF )
            // InternalMyDsl.g:55:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalMyDsl.g:62:1: ruleModel : ( ( rule__Model__RulesAssignment )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:66:2: ( ( ( rule__Model__RulesAssignment )* ) )
            // InternalMyDsl.g:67:2: ( ( rule__Model__RulesAssignment )* )
            {
            // InternalMyDsl.g:67:2: ( ( rule__Model__RulesAssignment )* )
            // InternalMyDsl.g:68:3: ( rule__Model__RulesAssignment )*
            {
             before(grammarAccess.getModelAccess().getRulesAssignment()); 
            // InternalMyDsl.g:69:3: ( rule__Model__RulesAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==14) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalMyDsl.g:69:4: rule__Model__RulesAssignment
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__Model__RulesAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getRulesAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleRules"
    // InternalMyDsl.g:78:1: entryRuleRules : ruleRules EOF ;
    public final void entryRuleRules() throws RecognitionException {
        try {
            // InternalMyDsl.g:79:1: ( ruleRules EOF )
            // InternalMyDsl.g:80:1: ruleRules EOF
            {
             before(grammarAccess.getRulesRule()); 
            pushFollow(FOLLOW_1);
            ruleRules();

            state._fsp--;

             after(grammarAccess.getRulesRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleRules"


    // $ANTLR start "ruleRules"
    // InternalMyDsl.g:87:1: ruleRules : ( ( rule__Rules__Group__0 ) ) ;
    public final void ruleRules() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:91:2: ( ( ( rule__Rules__Group__0 ) ) )
            // InternalMyDsl.g:92:2: ( ( rule__Rules__Group__0 ) )
            {
            // InternalMyDsl.g:92:2: ( ( rule__Rules__Group__0 ) )
            // InternalMyDsl.g:93:3: ( rule__Rules__Group__0 )
            {
             before(grammarAccess.getRulesAccess().getGroup()); 
            // InternalMyDsl.g:94:3: ( rule__Rules__Group__0 )
            // InternalMyDsl.g:94:4: rule__Rules__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Rules__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getRulesAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleRules"


    // $ANTLR start "entryRuleResult"
    // InternalMyDsl.g:103:1: entryRuleResult : ruleResult EOF ;
    public final void entryRuleResult() throws RecognitionException {
        try {
            // InternalMyDsl.g:104:1: ( ruleResult EOF )
            // InternalMyDsl.g:105:1: ruleResult EOF
            {
             before(grammarAccess.getResultRule()); 
            pushFollow(FOLLOW_1);
            ruleResult();

            state._fsp--;

             after(grammarAccess.getResultRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleResult"


    // $ANTLR start "ruleResult"
    // InternalMyDsl.g:112:1: ruleResult : ( ( rule__Result__Group__0 ) ) ;
    public final void ruleResult() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:116:2: ( ( ( rule__Result__Group__0 ) ) )
            // InternalMyDsl.g:117:2: ( ( rule__Result__Group__0 ) )
            {
            // InternalMyDsl.g:117:2: ( ( rule__Result__Group__0 ) )
            // InternalMyDsl.g:118:3: ( rule__Result__Group__0 )
            {
             before(grammarAccess.getResultAccess().getGroup()); 
            // InternalMyDsl.g:119:3: ( rule__Result__Group__0 )
            // InternalMyDsl.g:119:4: rule__Result__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Result__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getResultAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleResult"


    // $ANTLR start "entryRuleCondition"
    // InternalMyDsl.g:128:1: entryRuleCondition : ruleCondition EOF ;
    public final void entryRuleCondition() throws RecognitionException {
        try {
            // InternalMyDsl.g:129:1: ( ruleCondition EOF )
            // InternalMyDsl.g:130:1: ruleCondition EOF
            {
             before(grammarAccess.getConditionRule()); 
            pushFollow(FOLLOW_1);
            ruleCondition();

            state._fsp--;

             after(grammarAccess.getConditionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleCondition"


    // $ANTLR start "ruleCondition"
    // InternalMyDsl.g:137:1: ruleCondition : ( ( rule__Condition__Group__0 ) ) ;
    public final void ruleCondition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:141:2: ( ( ( rule__Condition__Group__0 ) ) )
            // InternalMyDsl.g:142:2: ( ( rule__Condition__Group__0 ) )
            {
            // InternalMyDsl.g:142:2: ( ( rule__Condition__Group__0 ) )
            // InternalMyDsl.g:143:3: ( rule__Condition__Group__0 )
            {
             before(grammarAccess.getConditionAccess().getGroup()); 
            // InternalMyDsl.g:144:3: ( rule__Condition__Group__0 )
            // InternalMyDsl.g:144:4: rule__Condition__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Condition__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getConditionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleCondition"


    // $ANTLR start "entryRuleConditionAtom"
    // InternalMyDsl.g:153:1: entryRuleConditionAtom : ruleConditionAtom EOF ;
    public final void entryRuleConditionAtom() throws RecognitionException {
        try {
            // InternalMyDsl.g:154:1: ( ruleConditionAtom EOF )
            // InternalMyDsl.g:155:1: ruleConditionAtom EOF
            {
             before(grammarAccess.getConditionAtomRule()); 
            pushFollow(FOLLOW_1);
            ruleConditionAtom();

            state._fsp--;

             after(grammarAccess.getConditionAtomRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleConditionAtom"


    // $ANTLR start "ruleConditionAtom"
    // InternalMyDsl.g:162:1: ruleConditionAtom : ( ( rule__ConditionAtom__Group__0 ) ) ;
    public final void ruleConditionAtom() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:166:2: ( ( ( rule__ConditionAtom__Group__0 ) ) )
            // InternalMyDsl.g:167:2: ( ( rule__ConditionAtom__Group__0 ) )
            {
            // InternalMyDsl.g:167:2: ( ( rule__ConditionAtom__Group__0 ) )
            // InternalMyDsl.g:168:3: ( rule__ConditionAtom__Group__0 )
            {
             before(grammarAccess.getConditionAtomAccess().getGroup()); 
            // InternalMyDsl.g:169:3: ( rule__ConditionAtom__Group__0 )
            // InternalMyDsl.g:169:4: rule__ConditionAtom__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getConditionAtomAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleConditionAtom"


    // $ANTLR start "rule__Rules__Group__0"
    // InternalMyDsl.g:177:1: rule__Rules__Group__0 : rule__Rules__Group__0__Impl rule__Rules__Group__1 ;
    public final void rule__Rules__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:181:1: ( rule__Rules__Group__0__Impl rule__Rules__Group__1 )
            // InternalMyDsl.g:182:2: rule__Rules__Group__0__Impl rule__Rules__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__Rules__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Rules__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rules__Group__0"


    // $ANTLR start "rule__Rules__Group__0__Impl"
    // InternalMyDsl.g:189:1: rule__Rules__Group__0__Impl : ( ( rule__Rules__ConditionAssignment_0 ) ) ;
    public final void rule__Rules__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:193:1: ( ( ( rule__Rules__ConditionAssignment_0 ) ) )
            // InternalMyDsl.g:194:1: ( ( rule__Rules__ConditionAssignment_0 ) )
            {
            // InternalMyDsl.g:194:1: ( ( rule__Rules__ConditionAssignment_0 ) )
            // InternalMyDsl.g:195:2: ( rule__Rules__ConditionAssignment_0 )
            {
             before(grammarAccess.getRulesAccess().getConditionAssignment_0()); 
            // InternalMyDsl.g:196:2: ( rule__Rules__ConditionAssignment_0 )
            // InternalMyDsl.g:196:3: rule__Rules__ConditionAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Rules__ConditionAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getRulesAccess().getConditionAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rules__Group__0__Impl"


    // $ANTLR start "rule__Rules__Group__1"
    // InternalMyDsl.g:204:1: rule__Rules__Group__1 : rule__Rules__Group__1__Impl ;
    public final void rule__Rules__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:208:1: ( rule__Rules__Group__1__Impl )
            // InternalMyDsl.g:209:2: rule__Rules__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Rules__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rules__Group__1"


    // $ANTLR start "rule__Rules__Group__1__Impl"
    // InternalMyDsl.g:215:1: rule__Rules__Group__1__Impl : ( ( rule__Rules__ResultAssignment_1 ) ) ;
    public final void rule__Rules__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:219:1: ( ( ( rule__Rules__ResultAssignment_1 ) ) )
            // InternalMyDsl.g:220:1: ( ( rule__Rules__ResultAssignment_1 ) )
            {
            // InternalMyDsl.g:220:1: ( ( rule__Rules__ResultAssignment_1 ) )
            // InternalMyDsl.g:221:2: ( rule__Rules__ResultAssignment_1 )
            {
             before(grammarAccess.getRulesAccess().getResultAssignment_1()); 
            // InternalMyDsl.g:222:2: ( rule__Rules__ResultAssignment_1 )
            // InternalMyDsl.g:222:3: rule__Rules__ResultAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Rules__ResultAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getRulesAccess().getResultAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rules__Group__1__Impl"


    // $ANTLR start "rule__Result__Group__0"
    // InternalMyDsl.g:231:1: rule__Result__Group__0 : rule__Result__Group__0__Impl rule__Result__Group__1 ;
    public final void rule__Result__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:235:1: ( rule__Result__Group__0__Impl rule__Result__Group__1 )
            // InternalMyDsl.g:236:2: rule__Result__Group__0__Impl rule__Result__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__Result__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Result__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__0"


    // $ANTLR start "rule__Result__Group__0__Impl"
    // InternalMyDsl.g:243:1: rule__Result__Group__0__Impl : ( '(' ) ;
    public final void rule__Result__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:247:1: ( ( '(' ) )
            // InternalMyDsl.g:248:1: ( '(' )
            {
            // InternalMyDsl.g:248:1: ( '(' )
            // InternalMyDsl.g:249:2: '('
            {
             before(grammarAccess.getResultAccess().getLeftParenthesisKeyword_0()); 
            match(input,11,FOLLOW_2); 
             after(grammarAccess.getResultAccess().getLeftParenthesisKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__0__Impl"


    // $ANTLR start "rule__Result__Group__1"
    // InternalMyDsl.g:258:1: rule__Result__Group__1 : rule__Result__Group__1__Impl rule__Result__Group__2 ;
    public final void rule__Result__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:262:1: ( rule__Result__Group__1__Impl rule__Result__Group__2 )
            // InternalMyDsl.g:263:2: rule__Result__Group__1__Impl rule__Result__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__Result__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Result__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__1"


    // $ANTLR start "rule__Result__Group__1__Impl"
    // InternalMyDsl.g:270:1: rule__Result__Group__1__Impl : ( ( rule__Result__ValuesAssignment_1 ) ) ;
    public final void rule__Result__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:274:1: ( ( ( rule__Result__ValuesAssignment_1 ) ) )
            // InternalMyDsl.g:275:1: ( ( rule__Result__ValuesAssignment_1 ) )
            {
            // InternalMyDsl.g:275:1: ( ( rule__Result__ValuesAssignment_1 ) )
            // InternalMyDsl.g:276:2: ( rule__Result__ValuesAssignment_1 )
            {
             before(grammarAccess.getResultAccess().getValuesAssignment_1()); 
            // InternalMyDsl.g:277:2: ( rule__Result__ValuesAssignment_1 )
            // InternalMyDsl.g:277:3: rule__Result__ValuesAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Result__ValuesAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getResultAccess().getValuesAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__1__Impl"


    // $ANTLR start "rule__Result__Group__2"
    // InternalMyDsl.g:285:1: rule__Result__Group__2 : rule__Result__Group__2__Impl rule__Result__Group__3 ;
    public final void rule__Result__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:289:1: ( rule__Result__Group__2__Impl rule__Result__Group__3 )
            // InternalMyDsl.g:290:2: rule__Result__Group__2__Impl rule__Result__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__Result__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Result__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__2"


    // $ANTLR start "rule__Result__Group__2__Impl"
    // InternalMyDsl.g:297:1: rule__Result__Group__2__Impl : ( ( rule__Result__Group_2__0 )* ) ;
    public final void rule__Result__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:301:1: ( ( ( rule__Result__Group_2__0 )* ) )
            // InternalMyDsl.g:302:1: ( ( rule__Result__Group_2__0 )* )
            {
            // InternalMyDsl.g:302:1: ( ( rule__Result__Group_2__0 )* )
            // InternalMyDsl.g:303:2: ( rule__Result__Group_2__0 )*
            {
             before(grammarAccess.getResultAccess().getGroup_2()); 
            // InternalMyDsl.g:304:2: ( rule__Result__Group_2__0 )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==13) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalMyDsl.g:304:3: rule__Result__Group_2__0
            	    {
            	    pushFollow(FOLLOW_7);
            	    rule__Result__Group_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

             after(grammarAccess.getResultAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__2__Impl"


    // $ANTLR start "rule__Result__Group__3"
    // InternalMyDsl.g:312:1: rule__Result__Group__3 : rule__Result__Group__3__Impl ;
    public final void rule__Result__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:316:1: ( rule__Result__Group__3__Impl )
            // InternalMyDsl.g:317:2: rule__Result__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Result__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__3"


    // $ANTLR start "rule__Result__Group__3__Impl"
    // InternalMyDsl.g:323:1: rule__Result__Group__3__Impl : ( ')' ) ;
    public final void rule__Result__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:327:1: ( ( ')' ) )
            // InternalMyDsl.g:328:1: ( ')' )
            {
            // InternalMyDsl.g:328:1: ( ')' )
            // InternalMyDsl.g:329:2: ')'
            {
             before(grammarAccess.getResultAccess().getRightParenthesisKeyword_3()); 
            match(input,12,FOLLOW_2); 
             after(grammarAccess.getResultAccess().getRightParenthesisKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group__3__Impl"


    // $ANTLR start "rule__Result__Group_2__0"
    // InternalMyDsl.g:339:1: rule__Result__Group_2__0 : rule__Result__Group_2__0__Impl rule__Result__Group_2__1 ;
    public final void rule__Result__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:343:1: ( rule__Result__Group_2__0__Impl rule__Result__Group_2__1 )
            // InternalMyDsl.g:344:2: rule__Result__Group_2__0__Impl rule__Result__Group_2__1
            {
            pushFollow(FOLLOW_5);
            rule__Result__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Result__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group_2__0"


    // $ANTLR start "rule__Result__Group_2__0__Impl"
    // InternalMyDsl.g:351:1: rule__Result__Group_2__0__Impl : ( ',' ) ;
    public final void rule__Result__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:355:1: ( ( ',' ) )
            // InternalMyDsl.g:356:1: ( ',' )
            {
            // InternalMyDsl.g:356:1: ( ',' )
            // InternalMyDsl.g:357:2: ','
            {
             before(grammarAccess.getResultAccess().getCommaKeyword_2_0()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getResultAccess().getCommaKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group_2__0__Impl"


    // $ANTLR start "rule__Result__Group_2__1"
    // InternalMyDsl.g:366:1: rule__Result__Group_2__1 : rule__Result__Group_2__1__Impl ;
    public final void rule__Result__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:370:1: ( rule__Result__Group_2__1__Impl )
            // InternalMyDsl.g:371:2: rule__Result__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Result__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group_2__1"


    // $ANTLR start "rule__Result__Group_2__1__Impl"
    // InternalMyDsl.g:377:1: rule__Result__Group_2__1__Impl : ( ( rule__Result__ValuesAssignment_2_1 ) ) ;
    public final void rule__Result__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:381:1: ( ( ( rule__Result__ValuesAssignment_2_1 ) ) )
            // InternalMyDsl.g:382:1: ( ( rule__Result__ValuesAssignment_2_1 ) )
            {
            // InternalMyDsl.g:382:1: ( ( rule__Result__ValuesAssignment_2_1 ) )
            // InternalMyDsl.g:383:2: ( rule__Result__ValuesAssignment_2_1 )
            {
             before(grammarAccess.getResultAccess().getValuesAssignment_2_1()); 
            // InternalMyDsl.g:384:2: ( rule__Result__ValuesAssignment_2_1 )
            // InternalMyDsl.g:384:3: rule__Result__ValuesAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Result__ValuesAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getResultAccess().getValuesAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__Group_2__1__Impl"


    // $ANTLR start "rule__Condition__Group__0"
    // InternalMyDsl.g:393:1: rule__Condition__Group__0 : rule__Condition__Group__0__Impl rule__Condition__Group__1 ;
    public final void rule__Condition__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:397:1: ( rule__Condition__Group__0__Impl rule__Condition__Group__1 )
            // InternalMyDsl.g:398:2: rule__Condition__Group__0__Impl rule__Condition__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__Condition__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Condition__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Condition__Group__0"


    // $ANTLR start "rule__Condition__Group__0__Impl"
    // InternalMyDsl.g:405:1: rule__Condition__Group__0__Impl : ( 'if:' ) ;
    public final void rule__Condition__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:409:1: ( ( 'if:' ) )
            // InternalMyDsl.g:410:1: ( 'if:' )
            {
            // InternalMyDsl.g:410:1: ( 'if:' )
            // InternalMyDsl.g:411:2: 'if:'
            {
             before(grammarAccess.getConditionAccess().getIfKeyword_0()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getConditionAccess().getIfKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Condition__Group__0__Impl"


    // $ANTLR start "rule__Condition__Group__1"
    // InternalMyDsl.g:420:1: rule__Condition__Group__1 : rule__Condition__Group__1__Impl ;
    public final void rule__Condition__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:424:1: ( rule__Condition__Group__1__Impl )
            // InternalMyDsl.g:425:2: rule__Condition__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Condition__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Condition__Group__1"


    // $ANTLR start "rule__Condition__Group__1__Impl"
    // InternalMyDsl.g:431:1: rule__Condition__Group__1__Impl : ( ( rule__Condition__ConditionAssignment_1 ) ) ;
    public final void rule__Condition__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:435:1: ( ( ( rule__Condition__ConditionAssignment_1 ) ) )
            // InternalMyDsl.g:436:1: ( ( rule__Condition__ConditionAssignment_1 ) )
            {
            // InternalMyDsl.g:436:1: ( ( rule__Condition__ConditionAssignment_1 ) )
            // InternalMyDsl.g:437:2: ( rule__Condition__ConditionAssignment_1 )
            {
             before(grammarAccess.getConditionAccess().getConditionAssignment_1()); 
            // InternalMyDsl.g:438:2: ( rule__Condition__ConditionAssignment_1 )
            // InternalMyDsl.g:438:3: rule__Condition__ConditionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Condition__ConditionAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getConditionAccess().getConditionAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Condition__Group__1__Impl"


    // $ANTLR start "rule__ConditionAtom__Group__0"
    // InternalMyDsl.g:447:1: rule__ConditionAtom__Group__0 : rule__ConditionAtom__Group__0__Impl rule__ConditionAtom__Group__1 ;
    public final void rule__ConditionAtom__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:451:1: ( rule__ConditionAtom__Group__0__Impl rule__ConditionAtom__Group__1 )
            // InternalMyDsl.g:452:2: rule__ConditionAtom__Group__0__Impl rule__ConditionAtom__Group__1
            {
            pushFollow(FOLLOW_8);
            rule__ConditionAtom__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__0"


    // $ANTLR start "rule__ConditionAtom__Group__0__Impl"
    // InternalMyDsl.g:459:1: rule__ConditionAtom__Group__0__Impl : ( ( rule__ConditionAtom__NameAssignment_0 ) ) ;
    public final void rule__ConditionAtom__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:463:1: ( ( ( rule__ConditionAtom__NameAssignment_0 ) ) )
            // InternalMyDsl.g:464:1: ( ( rule__ConditionAtom__NameAssignment_0 ) )
            {
            // InternalMyDsl.g:464:1: ( ( rule__ConditionAtom__NameAssignment_0 ) )
            // InternalMyDsl.g:465:2: ( rule__ConditionAtom__NameAssignment_0 )
            {
             before(grammarAccess.getConditionAtomAccess().getNameAssignment_0()); 
            // InternalMyDsl.g:466:2: ( rule__ConditionAtom__NameAssignment_0 )
            // InternalMyDsl.g:466:3: rule__ConditionAtom__NameAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__ConditionAtom__NameAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getConditionAtomAccess().getNameAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__0__Impl"


    // $ANTLR start "rule__ConditionAtom__Group__1"
    // InternalMyDsl.g:474:1: rule__ConditionAtom__Group__1 : rule__ConditionAtom__Group__1__Impl rule__ConditionAtom__Group__2 ;
    public final void rule__ConditionAtom__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:478:1: ( rule__ConditionAtom__Group__1__Impl rule__ConditionAtom__Group__2 )
            // InternalMyDsl.g:479:2: rule__ConditionAtom__Group__1__Impl rule__ConditionAtom__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__ConditionAtom__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__1"


    // $ANTLR start "rule__ConditionAtom__Group__1__Impl"
    // InternalMyDsl.g:486:1: rule__ConditionAtom__Group__1__Impl : ( '=' ) ;
    public final void rule__ConditionAtom__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:490:1: ( ( '=' ) )
            // InternalMyDsl.g:491:1: ( '=' )
            {
            // InternalMyDsl.g:491:1: ( '=' )
            // InternalMyDsl.g:492:2: '='
            {
             before(grammarAccess.getConditionAtomAccess().getEqualsSignKeyword_1()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getConditionAtomAccess().getEqualsSignKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__1__Impl"


    // $ANTLR start "rule__ConditionAtom__Group__2"
    // InternalMyDsl.g:501:1: rule__ConditionAtom__Group__2 : rule__ConditionAtom__Group__2__Impl rule__ConditionAtom__Group__3 ;
    public final void rule__ConditionAtom__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:505:1: ( rule__ConditionAtom__Group__2__Impl rule__ConditionAtom__Group__3 )
            // InternalMyDsl.g:506:2: rule__ConditionAtom__Group__2__Impl rule__ConditionAtom__Group__3
            {
            pushFollow(FOLLOW_9);
            rule__ConditionAtom__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__2"


    // $ANTLR start "rule__ConditionAtom__Group__2__Impl"
    // InternalMyDsl.g:513:1: rule__ConditionAtom__Group__2__Impl : ( ( rule__ConditionAtom__ValuesAssignment_2 ) ) ;
    public final void rule__ConditionAtom__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:517:1: ( ( ( rule__ConditionAtom__ValuesAssignment_2 ) ) )
            // InternalMyDsl.g:518:1: ( ( rule__ConditionAtom__ValuesAssignment_2 ) )
            {
            // InternalMyDsl.g:518:1: ( ( rule__ConditionAtom__ValuesAssignment_2 ) )
            // InternalMyDsl.g:519:2: ( rule__ConditionAtom__ValuesAssignment_2 )
            {
             before(grammarAccess.getConditionAtomAccess().getValuesAssignment_2()); 
            // InternalMyDsl.g:520:2: ( rule__ConditionAtom__ValuesAssignment_2 )
            // InternalMyDsl.g:520:3: rule__ConditionAtom__ValuesAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__ConditionAtom__ValuesAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getConditionAtomAccess().getValuesAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__2__Impl"


    // $ANTLR start "rule__ConditionAtom__Group__3"
    // InternalMyDsl.g:528:1: rule__ConditionAtom__Group__3 : rule__ConditionAtom__Group__3__Impl ;
    public final void rule__ConditionAtom__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:532:1: ( rule__ConditionAtom__Group__3__Impl )
            // InternalMyDsl.g:533:2: rule__ConditionAtom__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__3"


    // $ANTLR start "rule__ConditionAtom__Group__3__Impl"
    // InternalMyDsl.g:539:1: rule__ConditionAtom__Group__3__Impl : ( ( rule__ConditionAtom__Group_3__0 )* ) ;
    public final void rule__ConditionAtom__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:543:1: ( ( ( rule__ConditionAtom__Group_3__0 )* ) )
            // InternalMyDsl.g:544:1: ( ( rule__ConditionAtom__Group_3__0 )* )
            {
            // InternalMyDsl.g:544:1: ( ( rule__ConditionAtom__Group_3__0 )* )
            // InternalMyDsl.g:545:2: ( rule__ConditionAtom__Group_3__0 )*
            {
             before(grammarAccess.getConditionAtomAccess().getGroup_3()); 
            // InternalMyDsl.g:546:2: ( rule__ConditionAtom__Group_3__0 )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==13) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // InternalMyDsl.g:546:3: rule__ConditionAtom__Group_3__0
            	    {
            	    pushFollow(FOLLOW_7);
            	    rule__ConditionAtom__Group_3__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

             after(grammarAccess.getConditionAtomAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group__3__Impl"


    // $ANTLR start "rule__ConditionAtom__Group_3__0"
    // InternalMyDsl.g:555:1: rule__ConditionAtom__Group_3__0 : rule__ConditionAtom__Group_3__0__Impl rule__ConditionAtom__Group_3__1 ;
    public final void rule__ConditionAtom__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:559:1: ( rule__ConditionAtom__Group_3__0__Impl rule__ConditionAtom__Group_3__1 )
            // InternalMyDsl.g:560:2: rule__ConditionAtom__Group_3__0__Impl rule__ConditionAtom__Group_3__1
            {
            pushFollow(FOLLOW_5);
            rule__ConditionAtom__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group_3__0"


    // $ANTLR start "rule__ConditionAtom__Group_3__0__Impl"
    // InternalMyDsl.g:567:1: rule__ConditionAtom__Group_3__0__Impl : ( ',' ) ;
    public final void rule__ConditionAtom__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:571:1: ( ( ',' ) )
            // InternalMyDsl.g:572:1: ( ',' )
            {
            // InternalMyDsl.g:572:1: ( ',' )
            // InternalMyDsl.g:573:2: ','
            {
             before(grammarAccess.getConditionAtomAccess().getCommaKeyword_3_0()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getConditionAtomAccess().getCommaKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group_3__0__Impl"


    // $ANTLR start "rule__ConditionAtom__Group_3__1"
    // InternalMyDsl.g:582:1: rule__ConditionAtom__Group_3__1 : rule__ConditionAtom__Group_3__1__Impl ;
    public final void rule__ConditionAtom__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:586:1: ( rule__ConditionAtom__Group_3__1__Impl )
            // InternalMyDsl.g:587:2: rule__ConditionAtom__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ConditionAtom__Group_3__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group_3__1"


    // $ANTLR start "rule__ConditionAtom__Group_3__1__Impl"
    // InternalMyDsl.g:593:1: rule__ConditionAtom__Group_3__1__Impl : ( ( rule__ConditionAtom__ValuesAssignment_3_1 ) ) ;
    public final void rule__ConditionAtom__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:597:1: ( ( ( rule__ConditionAtom__ValuesAssignment_3_1 ) ) )
            // InternalMyDsl.g:598:1: ( ( rule__ConditionAtom__ValuesAssignment_3_1 ) )
            {
            // InternalMyDsl.g:598:1: ( ( rule__ConditionAtom__ValuesAssignment_3_1 ) )
            // InternalMyDsl.g:599:2: ( rule__ConditionAtom__ValuesAssignment_3_1 )
            {
             before(grammarAccess.getConditionAtomAccess().getValuesAssignment_3_1()); 
            // InternalMyDsl.g:600:2: ( rule__ConditionAtom__ValuesAssignment_3_1 )
            // InternalMyDsl.g:600:3: rule__ConditionAtom__ValuesAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__ConditionAtom__ValuesAssignment_3_1();

            state._fsp--;


            }

             after(grammarAccess.getConditionAtomAccess().getValuesAssignment_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__Group_3__1__Impl"


    // $ANTLR start "rule__Model__RulesAssignment"
    // InternalMyDsl.g:609:1: rule__Model__RulesAssignment : ( ruleRules ) ;
    public final void rule__Model__RulesAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:613:1: ( ( ruleRules ) )
            // InternalMyDsl.g:614:2: ( ruleRules )
            {
            // InternalMyDsl.g:614:2: ( ruleRules )
            // InternalMyDsl.g:615:3: ruleRules
            {
             before(grammarAccess.getModelAccess().getRulesRulesParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleRules();

            state._fsp--;

             after(grammarAccess.getModelAccess().getRulesRulesParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__RulesAssignment"


    // $ANTLR start "rule__Rules__ConditionAssignment_0"
    // InternalMyDsl.g:624:1: rule__Rules__ConditionAssignment_0 : ( ruleCondition ) ;
    public final void rule__Rules__ConditionAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:628:1: ( ( ruleCondition ) )
            // InternalMyDsl.g:629:2: ( ruleCondition )
            {
            // InternalMyDsl.g:629:2: ( ruleCondition )
            // InternalMyDsl.g:630:3: ruleCondition
            {
             before(grammarAccess.getRulesAccess().getConditionConditionParserRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleCondition();

            state._fsp--;

             after(grammarAccess.getRulesAccess().getConditionConditionParserRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rules__ConditionAssignment_0"


    // $ANTLR start "rule__Rules__ResultAssignment_1"
    // InternalMyDsl.g:639:1: rule__Rules__ResultAssignment_1 : ( ruleResult ) ;
    public final void rule__Rules__ResultAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:643:1: ( ( ruleResult ) )
            // InternalMyDsl.g:644:2: ( ruleResult )
            {
            // InternalMyDsl.g:644:2: ( ruleResult )
            // InternalMyDsl.g:645:3: ruleResult
            {
             before(grammarAccess.getRulesAccess().getResultResultParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResult();

            state._fsp--;

             after(grammarAccess.getRulesAccess().getResultResultParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Rules__ResultAssignment_1"


    // $ANTLR start "rule__Result__ValuesAssignment_1"
    // InternalMyDsl.g:654:1: rule__Result__ValuesAssignment_1 : ( RULE_STRING ) ;
    public final void rule__Result__ValuesAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:658:1: ( ( RULE_STRING ) )
            // InternalMyDsl.g:659:2: ( RULE_STRING )
            {
            // InternalMyDsl.g:659:2: ( RULE_STRING )
            // InternalMyDsl.g:660:3: RULE_STRING
            {
             before(grammarAccess.getResultAccess().getValuesSTRINGTerminalRuleCall_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getResultAccess().getValuesSTRINGTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__ValuesAssignment_1"


    // $ANTLR start "rule__Result__ValuesAssignment_2_1"
    // InternalMyDsl.g:669:1: rule__Result__ValuesAssignment_2_1 : ( RULE_STRING ) ;
    public final void rule__Result__ValuesAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:673:1: ( ( RULE_STRING ) )
            // InternalMyDsl.g:674:2: ( RULE_STRING )
            {
            // InternalMyDsl.g:674:2: ( RULE_STRING )
            // InternalMyDsl.g:675:3: RULE_STRING
            {
             before(grammarAccess.getResultAccess().getValuesSTRINGTerminalRuleCall_2_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getResultAccess().getValuesSTRINGTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Result__ValuesAssignment_2_1"


    // $ANTLR start "rule__Condition__ConditionAssignment_1"
    // InternalMyDsl.g:684:1: rule__Condition__ConditionAssignment_1 : ( ruleConditionAtom ) ;
    public final void rule__Condition__ConditionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:688:1: ( ( ruleConditionAtom ) )
            // InternalMyDsl.g:689:2: ( ruleConditionAtom )
            {
            // InternalMyDsl.g:689:2: ( ruleConditionAtom )
            // InternalMyDsl.g:690:3: ruleConditionAtom
            {
             before(grammarAccess.getConditionAccess().getConditionConditionAtomParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleConditionAtom();

            state._fsp--;

             after(grammarAccess.getConditionAccess().getConditionConditionAtomParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Condition__ConditionAssignment_1"


    // $ANTLR start "rule__ConditionAtom__NameAssignment_0"
    // InternalMyDsl.g:699:1: rule__ConditionAtom__NameAssignment_0 : ( RULE_STRING ) ;
    public final void rule__ConditionAtom__NameAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:703:1: ( ( RULE_STRING ) )
            // InternalMyDsl.g:704:2: ( RULE_STRING )
            {
            // InternalMyDsl.g:704:2: ( RULE_STRING )
            // InternalMyDsl.g:705:3: RULE_STRING
            {
             before(grammarAccess.getConditionAtomAccess().getNameSTRINGTerminalRuleCall_0_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getConditionAtomAccess().getNameSTRINGTerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__NameAssignment_0"


    // $ANTLR start "rule__ConditionAtom__ValuesAssignment_2"
    // InternalMyDsl.g:714:1: rule__ConditionAtom__ValuesAssignment_2 : ( RULE_STRING ) ;
    public final void rule__ConditionAtom__ValuesAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:718:1: ( ( RULE_STRING ) )
            // InternalMyDsl.g:719:2: ( RULE_STRING )
            {
            // InternalMyDsl.g:719:2: ( RULE_STRING )
            // InternalMyDsl.g:720:3: RULE_STRING
            {
             before(grammarAccess.getConditionAtomAccess().getValuesSTRINGTerminalRuleCall_2_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getConditionAtomAccess().getValuesSTRINGTerminalRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__ValuesAssignment_2"


    // $ANTLR start "rule__ConditionAtom__ValuesAssignment_3_1"
    // InternalMyDsl.g:729:1: rule__ConditionAtom__ValuesAssignment_3_1 : ( RULE_STRING ) ;
    public final void rule__ConditionAtom__ValuesAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMyDsl.g:733:1: ( ( RULE_STRING ) )
            // InternalMyDsl.g:734:2: ( RULE_STRING )
            {
            // InternalMyDsl.g:734:2: ( RULE_STRING )
            // InternalMyDsl.g:735:3: RULE_STRING
            {
             before(grammarAccess.getConditionAtomAccess().getValuesSTRINGTerminalRuleCall_3_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getConditionAtomAccess().getValuesSTRINGTerminalRuleCall_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ConditionAtom__ValuesAssignment_3_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000003000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000002000L});

}