package org.xtext.example.mydsl.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtext.example.mydsl.services.MyDslGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMyDslParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'('", "','", "')'", "'if:'", "'='"
    };
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=4;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int RULE_INT=6;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalMyDslParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMyDslParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMyDslParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMyDsl.g"; }



     	private MyDslGrammarAccess grammarAccess;

        public InternalMyDslParser(TokenStream input, MyDslGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Model";
       	}

       	@Override
       	protected MyDslGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleModel"
    // InternalMyDsl.g:64:1: entryRuleModel returns [EObject current=null] : iv_ruleModel= ruleModel EOF ;
    public final EObject entryRuleModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleModel = null;


        try {
            // InternalMyDsl.g:64:46: (iv_ruleModel= ruleModel EOF )
            // InternalMyDsl.g:65:2: iv_ruleModel= ruleModel EOF
            {
             newCompositeNode(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleModel=ruleModel();

            state._fsp--;

             current =iv_ruleModel; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalMyDsl.g:71:1: ruleModel returns [EObject current=null] : ( (lv_rules_0_0= ruleRules ) )* ;
    public final EObject ruleModel() throws RecognitionException {
        EObject current = null;

        EObject lv_rules_0_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:77:2: ( ( (lv_rules_0_0= ruleRules ) )* )
            // InternalMyDsl.g:78:2: ( (lv_rules_0_0= ruleRules ) )*
            {
            // InternalMyDsl.g:78:2: ( (lv_rules_0_0= ruleRules ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==14) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalMyDsl.g:79:3: (lv_rules_0_0= ruleRules )
            	    {
            	    // InternalMyDsl.g:79:3: (lv_rules_0_0= ruleRules )
            	    // InternalMyDsl.g:80:4: lv_rules_0_0= ruleRules
            	    {

            	    				newCompositeNode(grammarAccess.getModelAccess().getRulesRulesParserRuleCall_0());
            	    			
            	    pushFollow(FOLLOW_3);
            	    lv_rules_0_0=ruleRules();

            	    state._fsp--;


            	    				if (current==null) {
            	    					current = createModelElementForParent(grammarAccess.getModelRule());
            	    				}
            	    				add(
            	    					current,
            	    					"rules",
            	    					lv_rules_0_0,
            	    					"org.xtext.example.mydsl.MyDsl.Rules");
            	    				afterParserOrEnumRuleCall();
            	    			

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleRules"
    // InternalMyDsl.g:100:1: entryRuleRules returns [EObject current=null] : iv_ruleRules= ruleRules EOF ;
    public final EObject entryRuleRules() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRules = null;


        try {
            // InternalMyDsl.g:100:46: (iv_ruleRules= ruleRules EOF )
            // InternalMyDsl.g:101:2: iv_ruleRules= ruleRules EOF
            {
             newCompositeNode(grammarAccess.getRulesRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleRules=ruleRules();

            state._fsp--;

             current =iv_ruleRules; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRules"


    // $ANTLR start "ruleRules"
    // InternalMyDsl.g:107:1: ruleRules returns [EObject current=null] : ( ( (lv_condition_0_0= ruleCondition ) ) ( (lv_result_1_0= ruleResult ) ) ) ;
    public final EObject ruleRules() throws RecognitionException {
        EObject current = null;

        EObject lv_condition_0_0 = null;

        EObject lv_result_1_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:113:2: ( ( ( (lv_condition_0_0= ruleCondition ) ) ( (lv_result_1_0= ruleResult ) ) ) )
            // InternalMyDsl.g:114:2: ( ( (lv_condition_0_0= ruleCondition ) ) ( (lv_result_1_0= ruleResult ) ) )
            {
            // InternalMyDsl.g:114:2: ( ( (lv_condition_0_0= ruleCondition ) ) ( (lv_result_1_0= ruleResult ) ) )
            // InternalMyDsl.g:115:3: ( (lv_condition_0_0= ruleCondition ) ) ( (lv_result_1_0= ruleResult ) )
            {
            // InternalMyDsl.g:115:3: ( (lv_condition_0_0= ruleCondition ) )
            // InternalMyDsl.g:116:4: (lv_condition_0_0= ruleCondition )
            {
            // InternalMyDsl.g:116:4: (lv_condition_0_0= ruleCondition )
            // InternalMyDsl.g:117:5: lv_condition_0_0= ruleCondition
            {

            					newCompositeNode(grammarAccess.getRulesAccess().getConditionConditionParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_4);
            lv_condition_0_0=ruleCondition();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRulesRule());
            					}
            					set(
            						current,
            						"condition",
            						lv_condition_0_0,
            						"org.xtext.example.mydsl.MyDsl.Condition");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalMyDsl.g:134:3: ( (lv_result_1_0= ruleResult ) )
            // InternalMyDsl.g:135:4: (lv_result_1_0= ruleResult )
            {
            // InternalMyDsl.g:135:4: (lv_result_1_0= ruleResult )
            // InternalMyDsl.g:136:5: lv_result_1_0= ruleResult
            {

            					newCompositeNode(grammarAccess.getRulesAccess().getResultResultParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_result_1_0=ruleResult();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRulesRule());
            					}
            					set(
            						current,
            						"result",
            						lv_result_1_0,
            						"org.xtext.example.mydsl.MyDsl.Result");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRules"


    // $ANTLR start "entryRuleResult"
    // InternalMyDsl.g:157:1: entryRuleResult returns [EObject current=null] : iv_ruleResult= ruleResult EOF ;
    public final EObject entryRuleResult() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleResult = null;


        try {
            // InternalMyDsl.g:157:47: (iv_ruleResult= ruleResult EOF )
            // InternalMyDsl.g:158:2: iv_ruleResult= ruleResult EOF
            {
             newCompositeNode(grammarAccess.getResultRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleResult=ruleResult();

            state._fsp--;

             current =iv_ruleResult; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResult"


    // $ANTLR start "ruleResult"
    // InternalMyDsl.g:164:1: ruleResult returns [EObject current=null] : (otherlv_0= '(' ( (lv_values_1_0= RULE_STRING ) ) (otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) ) )* otherlv_4= ')' ) ;
    public final EObject ruleResult() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_values_1_0=null;
        Token otherlv_2=null;
        Token lv_values_3_0=null;
        Token otherlv_4=null;


        	enterRule();

        try {
            // InternalMyDsl.g:170:2: ( (otherlv_0= '(' ( (lv_values_1_0= RULE_STRING ) ) (otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) ) )* otherlv_4= ')' ) )
            // InternalMyDsl.g:171:2: (otherlv_0= '(' ( (lv_values_1_0= RULE_STRING ) ) (otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) ) )* otherlv_4= ')' )
            {
            // InternalMyDsl.g:171:2: (otherlv_0= '(' ( (lv_values_1_0= RULE_STRING ) ) (otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) ) )* otherlv_4= ')' )
            // InternalMyDsl.g:172:3: otherlv_0= '(' ( (lv_values_1_0= RULE_STRING ) ) (otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) ) )* otherlv_4= ')'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_5); 

            			newLeafNode(otherlv_0, grammarAccess.getResultAccess().getLeftParenthesisKeyword_0());
            		
            // InternalMyDsl.g:176:3: ( (lv_values_1_0= RULE_STRING ) )
            // InternalMyDsl.g:177:4: (lv_values_1_0= RULE_STRING )
            {
            // InternalMyDsl.g:177:4: (lv_values_1_0= RULE_STRING )
            // InternalMyDsl.g:178:5: lv_values_1_0= RULE_STRING
            {
            lv_values_1_0=(Token)match(input,RULE_STRING,FOLLOW_6); 

            					newLeafNode(lv_values_1_0, grammarAccess.getResultAccess().getValuesSTRINGTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getResultRule());
            					}
            					addWithLastConsumed(
            						current,
            						"values",
            						lv_values_1_0,
            						"org.eclipse.xtext.common.Terminals.STRING");
            				

            }


            }

            // InternalMyDsl.g:194:3: (otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==12) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalMyDsl.g:195:4: otherlv_2= ',' ( (lv_values_3_0= RULE_STRING ) )
            	    {
            	    otherlv_2=(Token)match(input,12,FOLLOW_5); 

            	    				newLeafNode(otherlv_2, grammarAccess.getResultAccess().getCommaKeyword_2_0());
            	    			
            	    // InternalMyDsl.g:199:4: ( (lv_values_3_0= RULE_STRING ) )
            	    // InternalMyDsl.g:200:5: (lv_values_3_0= RULE_STRING )
            	    {
            	    // InternalMyDsl.g:200:5: (lv_values_3_0= RULE_STRING )
            	    // InternalMyDsl.g:201:6: lv_values_3_0= RULE_STRING
            	    {
            	    lv_values_3_0=(Token)match(input,RULE_STRING,FOLLOW_6); 

            	    						newLeafNode(lv_values_3_0, grammarAccess.getResultAccess().getValuesSTRINGTerminalRuleCall_2_1_0());
            	    					

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getResultRule());
            	    						}
            	    						addWithLastConsumed(
            	    							current,
            	    							"values",
            	    							lv_values_3_0,
            	    							"org.eclipse.xtext.common.Terminals.STRING");
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            otherlv_4=(Token)match(input,13,FOLLOW_2); 

            			newLeafNode(otherlv_4, grammarAccess.getResultAccess().getRightParenthesisKeyword_3());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResult"


    // $ANTLR start "entryRuleCondition"
    // InternalMyDsl.g:226:1: entryRuleCondition returns [EObject current=null] : iv_ruleCondition= ruleCondition EOF ;
    public final EObject entryRuleCondition() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleCondition = null;


        try {
            // InternalMyDsl.g:226:50: (iv_ruleCondition= ruleCondition EOF )
            // InternalMyDsl.g:227:2: iv_ruleCondition= ruleCondition EOF
            {
             newCompositeNode(grammarAccess.getConditionRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleCondition=ruleCondition();

            state._fsp--;

             current =iv_ruleCondition; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleCondition"


    // $ANTLR start "ruleCondition"
    // InternalMyDsl.g:233:1: ruleCondition returns [EObject current=null] : (otherlv_0= 'if:' ( (lv_condition_1_0= ruleConditionAtom ) ) ) ;
    public final EObject ruleCondition() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        EObject lv_condition_1_0 = null;



        	enterRule();

        try {
            // InternalMyDsl.g:239:2: ( (otherlv_0= 'if:' ( (lv_condition_1_0= ruleConditionAtom ) ) ) )
            // InternalMyDsl.g:240:2: (otherlv_0= 'if:' ( (lv_condition_1_0= ruleConditionAtom ) ) )
            {
            // InternalMyDsl.g:240:2: (otherlv_0= 'if:' ( (lv_condition_1_0= ruleConditionAtom ) ) )
            // InternalMyDsl.g:241:3: otherlv_0= 'if:' ( (lv_condition_1_0= ruleConditionAtom ) )
            {
            otherlv_0=(Token)match(input,14,FOLLOW_5); 

            			newLeafNode(otherlv_0, grammarAccess.getConditionAccess().getIfKeyword_0());
            		
            // InternalMyDsl.g:245:3: ( (lv_condition_1_0= ruleConditionAtom ) )
            // InternalMyDsl.g:246:4: (lv_condition_1_0= ruleConditionAtom )
            {
            // InternalMyDsl.g:246:4: (lv_condition_1_0= ruleConditionAtom )
            // InternalMyDsl.g:247:5: lv_condition_1_0= ruleConditionAtom
            {

            					newCompositeNode(grammarAccess.getConditionAccess().getConditionConditionAtomParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_condition_1_0=ruleConditionAtom();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getConditionRule());
            					}
            					set(
            						current,
            						"condition",
            						lv_condition_1_0,
            						"org.xtext.example.mydsl.MyDsl.ConditionAtom");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleCondition"


    // $ANTLR start "entryRuleConditionAtom"
    // InternalMyDsl.g:268:1: entryRuleConditionAtom returns [EObject current=null] : iv_ruleConditionAtom= ruleConditionAtom EOF ;
    public final EObject entryRuleConditionAtom() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConditionAtom = null;


        try {
            // InternalMyDsl.g:268:54: (iv_ruleConditionAtom= ruleConditionAtom EOF )
            // InternalMyDsl.g:269:2: iv_ruleConditionAtom= ruleConditionAtom EOF
            {
             newCompositeNode(grammarAccess.getConditionAtomRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConditionAtom=ruleConditionAtom();

            state._fsp--;

             current =iv_ruleConditionAtom; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConditionAtom"


    // $ANTLR start "ruleConditionAtom"
    // InternalMyDsl.g:275:1: ruleConditionAtom returns [EObject current=null] : ( ( (lv_name_0_0= RULE_STRING ) ) otherlv_1= '=' ( (lv_values_2_0= RULE_STRING ) ) (otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) ) )* ) ;
    public final EObject ruleConditionAtom() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;
        Token otherlv_1=null;
        Token lv_values_2_0=null;
        Token otherlv_3=null;
        Token lv_values_4_0=null;


        	enterRule();

        try {
            // InternalMyDsl.g:281:2: ( ( ( (lv_name_0_0= RULE_STRING ) ) otherlv_1= '=' ( (lv_values_2_0= RULE_STRING ) ) (otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) ) )* ) )
            // InternalMyDsl.g:282:2: ( ( (lv_name_0_0= RULE_STRING ) ) otherlv_1= '=' ( (lv_values_2_0= RULE_STRING ) ) (otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) ) )* )
            {
            // InternalMyDsl.g:282:2: ( ( (lv_name_0_0= RULE_STRING ) ) otherlv_1= '=' ( (lv_values_2_0= RULE_STRING ) ) (otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) ) )* )
            // InternalMyDsl.g:283:3: ( (lv_name_0_0= RULE_STRING ) ) otherlv_1= '=' ( (lv_values_2_0= RULE_STRING ) ) (otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) ) )*
            {
            // InternalMyDsl.g:283:3: ( (lv_name_0_0= RULE_STRING ) )
            // InternalMyDsl.g:284:4: (lv_name_0_0= RULE_STRING )
            {
            // InternalMyDsl.g:284:4: (lv_name_0_0= RULE_STRING )
            // InternalMyDsl.g:285:5: lv_name_0_0= RULE_STRING
            {
            lv_name_0_0=(Token)match(input,RULE_STRING,FOLLOW_7); 

            					newLeafNode(lv_name_0_0, grammarAccess.getConditionAtomAccess().getNameSTRINGTerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getConditionAtomRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_0_0,
            						"org.eclipse.xtext.common.Terminals.STRING");
            				

            }


            }

            otherlv_1=(Token)match(input,15,FOLLOW_5); 

            			newLeafNode(otherlv_1, grammarAccess.getConditionAtomAccess().getEqualsSignKeyword_1());
            		
            // InternalMyDsl.g:305:3: ( (lv_values_2_0= RULE_STRING ) )
            // InternalMyDsl.g:306:4: (lv_values_2_0= RULE_STRING )
            {
            // InternalMyDsl.g:306:4: (lv_values_2_0= RULE_STRING )
            // InternalMyDsl.g:307:5: lv_values_2_0= RULE_STRING
            {
            lv_values_2_0=(Token)match(input,RULE_STRING,FOLLOW_8); 

            					newLeafNode(lv_values_2_0, grammarAccess.getConditionAtomAccess().getValuesSTRINGTerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getConditionAtomRule());
            					}
            					addWithLastConsumed(
            						current,
            						"values",
            						lv_values_2_0,
            						"org.eclipse.xtext.common.Terminals.STRING");
            				

            }


            }

            // InternalMyDsl.g:323:3: (otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) ) )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==12) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // InternalMyDsl.g:324:4: otherlv_3= ',' ( (lv_values_4_0= RULE_STRING ) )
            	    {
            	    otherlv_3=(Token)match(input,12,FOLLOW_5); 

            	    				newLeafNode(otherlv_3, grammarAccess.getConditionAtomAccess().getCommaKeyword_3_0());
            	    			
            	    // InternalMyDsl.g:328:4: ( (lv_values_4_0= RULE_STRING ) )
            	    // InternalMyDsl.g:329:5: (lv_values_4_0= RULE_STRING )
            	    {
            	    // InternalMyDsl.g:329:5: (lv_values_4_0= RULE_STRING )
            	    // InternalMyDsl.g:330:6: lv_values_4_0= RULE_STRING
            	    {
            	    lv_values_4_0=(Token)match(input,RULE_STRING,FOLLOW_8); 

            	    						newLeafNode(lv_values_4_0, grammarAccess.getConditionAtomAccess().getValuesSTRINGTerminalRuleCall_3_1_0());
            	    					

            	    						if (current==null) {
            	    							current = createModelElement(grammarAccess.getConditionAtomRule());
            	    						}
            	    						addWithLastConsumed(
            	    							current,
            	    							"values",
            	    							lv_values_4_0,
            	    							"org.eclipse.xtext.common.Terminals.STRING");
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConditionAtom"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000003000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000001002L});

}